function [betahat, betavar, betavar1, kappahat, CVs]=ardlpmg_bc(y,x)

[T,n]=size(y);
%% Step 1: estimation of data
% estimate all parameters
Q=ardlpmg_full(y,x);
k=size(x,3);

Th=(T+1)/2;

% generate data
R=5000; % number of replications for simulations
betaall=zeros(R,k); betaalla=zeros(R,k); betaallb=zeros(R,k);
sball=zeros(R,k);
tallj1=zeros(R,k);
for r=1:R
    [yr,xr]=gen_data_ardlbc(Q,y, x);    
    [betahat,~,sb]=ardlpmg(yr,xr);
    betaall(r,:)=betahat';
    sball(r,:)=sb';


 [bj, ~,bjstd,betahat1,betahat2 ]=ardlpmg_vj(yr,xr, 1/3, 1);
    betaalla(r,:)=betahat1';
    betaallb(r,:)=betahat2';
    % jackknife s.e.s
    tallj1(r,:)=(bj-Q.beta)./bjstd;
end %r

% compute bias-adjusted estimator and its variance
bias=mean(betaall)'-Q.beta; biasa=mean(betaalla)'-Q.beta; biasb=mean(betaallb)'-Q.beta;
bias2=(biasa+biasb)/2;
betahat= Q.beta-bias;
betavar=var(betaall)';

% now compute variance
sv=zeros(k,k); sx=Q.sx;
for i=1:n
    xi=squeeze(x(:,i,:));
    yi=y(:,i);
    % find available sample (time periods with NaNs are dropped)
    ni=isnan([yi,xi]);
    omit=(sum(ni,2)>0);
    yi=yi(not(omit));
    xi=xi(not(omit),:);
    Ti=size(yi,1);
     
    Wi=[yi(2:Ti,1)-yi(1:Ti-1,1),xi(2:Ti,:)-xi(1:Ti-1,:), ones(Ti-1,1)]; 
    Hi=[yi(1:Ti-1,1),xi(2:Ti,:),xi(1:Ti-1,:), ones(Ti-1,1)]; %, ones(T-1,1)
    P=Hi*inv(Hi'*Hi)*Hi';
    M=P-P*Wi*inv(Wi'*P*Wi)*Wi'*P;
    
    vinm= (yi(2:Ti,1)-xi(2:Ti,:)*betahat);
    sv=sv+((xi(2:Ti,:)'*M*(vinm*vinm')*M*xi(2:Ti,:)));
end
OM=inv(sx)*sv*inv(sx);
betavar1=diag(OM);


% now compute kappahat
kappahat=diag(bias./(bias2-bias));

% now compute CVs
betajackallhat=betaall-((betaalla+betaallb)/2-betaall)*kappahat;
tjackhatall=(betajackallhat-ones(R,1)*Q.beta')./sball;
CVs.jackhat=quantile(abs(tjackhatall),0.95);

kappa=diag([1/3;1/3]);
betajackall=betaall-((betaalla+betaallb)/2-betaall)*kappa;
tjackall=(betajackall-ones(R,1)*Q.beta')./sball;
CVs.jack13=quantile(abs(tjackall),0.95);
CVs.jack13_jf=quantile(abs(tallj1),0.95);

tallj2=zeros(R,k);
tallsb=zeros(R,k);
for r=1:R
    [yr,xr]=gen_data_ardlbc(Q,y, x);  
    % jackknife s.es
    p=1;
    [bj, ~,bstd,~,~ ]=ardlpmg_vj(yr,xr, kappahat, p);
    tallj2(r,:)=(bj-Q.beta)./bstd;
    % simul based bias corrected estimator s.e.s
    [b,~,sb]=ardlpmg(yr,xr);
    bbc=b-bias;
    tallsb(r,:)=(bbc-Q.beta)./sb;
end %r
CVs.jackhat_jf=quantile(abs(tallj2),0.95);
CVs.simulbased=quantile(abs(tallsb),0.95);

return