function [yr,xr]=gen_data_ardlbc(Q,ys, xs)

[T,n]=size(ys);
k=size(xs,3);

yr=NaN(T,n);
xr=NaN(T,n,k);


for i=1:n
   % Get sample start and end points
   Tstart=Q.sample(i,1);
   Tend=Q.sample(i,2);
   Ti=Tend-Tstart+1;
   % assign starting values
   xi=NaN(T,k);
   xi(Tstart:Tstart+1,:)=xs(Tstart:Tstart+1,i,:);
   %generate new residuals
    ui=Q.u(Tstart+2:Tend,:,i);
    %re-center
    ui   =   ui-ones(Ti-2,1)*( (ui'*ones(Ti-2,1)/(Ti-2))');
    % re-sample residuals
    ind =   ceil(rand(Ti-2,1)*(Ti-2));
    ur  =   ui(ind,:);
    %re-center
    ur   =   ur-ones(Ti-2,1)*( (ur'*ones(Ti-2,1)/(Ti-2))');
    %ur=ui;
   % generate new x 
   dxl=(xi(Tstart+1,:)-xi(Tstart,:))';
   for s=2:Ti-1
    dxi=Q.cx(:,i)+Q.xphi(:,:,i)*dxl+ur(s-1,:)';
    xi(Tstart+s,:)=dxi'+xi(Tstart+s-1,:);
    dxl=dxi;
   end
  xr(:,i,:)=xi; 
   %generate new residuals 
    vi=Q.v(Tstart+1:Tend,i);
    %re-center
    vi   =   vi-ones(Ti-1,1)*( (vi'*ones(Ti-1,1)/(Ti-1))');
    % re-sample residuals
    ind =   ceil(rand(Ti-1,1)*(Ti-1));
    vr  =   vi(ind,:);
    %re-center
    vr   =   vr-ones(Ti-1,1)*( (vr'*ones(Ti-1,1)/(Ti-1))');
    %vr=vi;
    yi=NaN(T,1);
    %assign starting value
    yi(Tstart,1)=ys(Tstart,i);
    % generate new y
    for s=1:Ti-1
        t=Tstart+s;
        yi(t,1)=yi(t-1,1)+Q.c(i,1)+Q.alpha(i,1)*(yi(t-1,1)-xi(t-1,:)*Q.beta)+(xi(t,:)-xi(t-1,:))*Q.delta(i,:)'+vr(s,:); 
    end
    yr(:,i)=yi;
end




return