function  [exi,Hi,dyi,Xi,yi_, Ti] = getvars(i,X,Y,p,beta)

k=size(X,3);
 % find available sample (time periods with NaNs are dropped)
 xi=squeeze(X(:,i,:));
 yi=Y(:,i);
 ni=isnan([yi,xi]);
 omit=(sum(ni,2)>0);
 incl=not(omit);
 yi=yi(incl);
 xi=xi(not(omit),:);
 Ti=size(xi,1);

yi_=yi(p:end-1,1);
xi_=xi(p:end-1,:); 

% 1. get exi
exi=yi_-xi_*beta;
 
% 2. get Hi
dX=zeros(Ti-p,(p-1)*k+1); % cont and p-1 lags
for j=1:p
    dX(:,(j-1)*k+1:j*k)=xi(p-j+2:Ti-j+1,:)-xi(p-j+1:Ti-j,:);
end
dY=zeros(Ti-p,p-1);
for j=2:p
    dY(:,j-1)=yi(p-j+2:Ti-j+1,1)-yi(p-j+1:Ti-j,1);
end
Wi=[dX,dY, ones(Ti-p,1)];
if rank(Wi'*Wi)< size(Wi,2)
    'check rank'
    Wi
    dbstop
end
Hi=eye(Ti-p)-Wi*inv(Wi'*Wi)*Wi';

% 3. get dyi
 dyi=yi(p+1:Ti,1)-yi(p:Ti-1,1);
% 4. get Xi matrix (Xi=xi_),y_
Xi=xi_;

end

