function [Res]=pmg_bc(y,x)

[T,n]=size(y);
k=size(x,3);
%% Step 1: estimation of data
% estimate all parameters
Q=pmg_full(y,x);

Th=(T+1)/2;

% generate data
R=5000; % number of replications for simulations
betaall=zeros(R,k); betaalla=zeros(R,k); betaallb=zeros(R,k);
sball=zeros(R,k);
for r=1:R
    [yr,xr]=gen_data_ardlbc(Q,y, x);    
    [b,sb]=PMGe(yr,xr,1);
    betaall(r,:)=b';
    sball(r,:)=sb';
    
    [y1r, y2r, x1r, x2r]=jacksubsamples(yr,xr,1);
    
    bja=PMGe(y1r,x1r,1);
    betaalla(r,:)=bja';
    bjb=PMGe(y2r,x2r,1);
    betaallb(r,:)=bjb';
end %r

% compute bias-adjusted estimator and its variance
bias=mean(betaall)'-Q.beta; biasa=mean(betaalla)'-Q.beta; biasb=mean(betaallb)'-Q.beta;
bias2=(biasa+biasb)/2;
% simulation-based and its variance
Res.simulbased.betahat= Q.beta-bias;
Res.simulbased.var=Q.var; %var(betaall);
betaalla=betaall-ones(R,1)*bias';
talla=(betaalla-ones(R,1)*Q.beta')./sball;
Res.simulbased.cv=quantile(abs(talla),0.95);

% jackknife corrected, kappa=1/3
   [y1, y2, x1, x2]=jacksubsamples(y,x,1);

    beta=PMGe(y,x,1);
    betaa=PMGe(y1,x1,1);
    betab=PMGe(y2,x2,1);
    kappa=diag([1/3;1/3]);
betajack=beta-kappa*((betaa+betab)/2-beta);
betajackall=betaall-((betaalla+betaallb)/2-betaall)*kappa;
tjackall=(betajackall-ones(R,1)*Q.beta')./sball;
Res.jack13.betahat=betajack;
Res.jack13.var=Q.var; %var(betajackall);
Res.jack13.cv=quantile(abs(tjackall),0.95);

% jackknife corrected using kappahat
kappahat=diag(bias./(bias2-bias));
betajackhat=beta-kappahat*((betaa+betab)/2-beta);
betajackallhat=betaall-((betaalla+betaallb)/2-betaall)*kappahat;
Res.jackhat.betahat=betajackhat;
Res.jackhat.var=Q.var; %var(betajackallhat);
tjackhatall=(betajackallhat-ones(R,1)*Q.beta')./sball;
Res.jackhat.cv=quantile(abs(tjackhatall),0.95);


return