function [betahat,stdbeta, iter, converge,Hi, Q, phi,ve]=PMGe(Y,X,p)

% Y is T x n
% X is T x n
[T,n]=size(Y);
% initial estimator 

%E-G pooled

A=0; B=0;
tau=ones(T,1);
Mh=eye(T)-tau*(inv(tau'*tau))*tau';
for i=1:n
    xi=X(:,i);
    yi=Y(:,i);
    A=A + xi'*Mh*xi;
    B=B + xi'*Mh*yi;
end

beta=inv(A)*B;



y_=Y(p:end-1,:);
x_=X(p:end-1,:);


% 1. get exi
ex=y_-beta*x_;

% 2. compute phihats and sigmais
phi=zeros(n,1);
sigi2=zeros(n,1);
for i=1:n
  exi=ex(:,i);
  %Hi=H(:,:,i);
   Hi=getHi(i,T,p,X,Y);
  dyi=Y(p+1:T,i)-Y(p:T-1,i);
  phi(i,1)=inv(exi'*Hi*exi)*exi'*Hi*dyi;
  sigi2(i,1)=(dyi-phi(i,1)*exi)'*Hi*(dyi-phi(i,1)*exi)/(T-p);
end


%now repeat

converge=false;
precision=1e-4;
maxiter=500;
iter=0;
while iter<maxiter && not(converge)
   %1. new beta 
   A=zeros(1,1);
   b=zeros(1,1);
   for i=1:n
        %Hi=H(:,:,i);
        Hi=getHi(i,T,p,X,Y);
        Xi=x_(:,i);
      A=A-phi(i,1)/sigi2(i,1)* phi(i,1) * Xi'*Hi*Xi;
      dyi=Y(p+1:T,i)-Y(p:T-1,i);
      b=b+phi(i,1)/sigi2(i,1)*Xi'*Hi*(dyi - phi(i,1)*y_(:,i));
   end
   
   betan=inv(A)*b;
   %2. get new phi and sigmai2
   
    ex=y_-betan*x_;
    phi=zeros(n,1);
    sigi2=zeros(n,1);
    for i=1:n
        exi=ex(:,i);
        %Hi=H(:,:,i);
        Hi=getHi(i,T,p,X,Y);
        dyi=Y(p+1:T,i)-Y(p:T-1,i);
        phi(i,1)=inv(exi'*Hi*exi)*exi'*Hi*dyi;
        sigi2(i,1)=(dyi-phi(i,1)*exi)'*Hi*(dyi-phi(i,1)*exi)/(T-p);
    end 
    %abs(betan-beta)
   converge=abs(betan-beta)<precision;
   beta=betan;
   iter=iter+1;
end

betahat=beta;
% now compute stdev

d=0;
for i=1:n
    Hi=getHi(i,T,p,X,Y);
    Xi=x_(:,i);
    d=d+phi(i,1)*phi(i,1)/sigi2(i,1)*Xi'*Hi*Xi;
end 

AV=inv(d);
 stdbeta=AV^0.5;


% now sandwich formula
eps=zeros(T-p,n);
ve=zeros(n,1);
ex=y_-betahat*x_;
d=0;
for i=1:n
    %Hi=H(:,:,i);
    Hi=getHi(i,T,p,X,Y);
    exi=ex(:,i);
    dyi=Y(p+1:T,i)-Y(p:T-1,i);
    eps(:,i)=Hi*(dyi - phi(i,1)*exi);
    ve(i,1)=eps(:,i)'*eps(:,i)/(T-p);
    Xi=x_(:,i);
    d=d+phi(i,1)*phi(i,1)*Xi'*Hi/ve(i,1)*Hi*Xi;
end 
Q=inv(A);
AVs=Q*d*Q';
 stdbetas=AVs^0.5;



return

