function [Res]=pmg_bc(y,x)

[T,n]=size(y);
%% Step 1: estimation of data
% estimate all parameters
Q=pmg_full(y,x);

Th=(T+1)/2;

% generate data
R=5000; % number of replications for simulations
betaall=zeros(R,1); betaalla=zeros(R,1); betaallb=zeros(R,1);
tall=zeros(R,1); sball=zeros(R,1);
for r=1:R
    [yr,xr]=gen_data_ardlbc(Q,y(1,:), x(1,:),T);    
    [b,sb]=PMGe(yr,xr,1);
    betaall(r,1)=b;
    tall(r,1)=(b-Q.beta)/sb;
    sball(r,1)=sb;
    
    x1r=xr(1:Th,:); y1r=yr(1:Th,:);
    x2r=xr(Th:T,:); y2r=yr(Th:T,:);
    
    betaalla(r,1)=PMGe(y1r,x1r,1);
    betaallb(r,1)=PMGe(y2r,x2r,1);
end %r

% compute bias-adjusted estimator and its variance
bias=mean(betaall)-Q.beta; biasa=mean(betaalla)-Q.beta; biasb=mean(betaallb)-Q.beta;
bias2=(biasa+biasb)/2;
% simulation-based and its variance
Res.simulbased.betahat= Q.beta-bias;
Res.simulbased.var=Q.var; %var(betaall);
betaalla=betaall-bias;
talla=(betaalla-Q.beta)./sball;
Res.simulbased.cv=quantile(abs(talla),0.95);

% jackknife corrected, kappa=1/3
    x1=x(1:Th,:); y1=y(1:Th,:);
    x2=x(Th:T,:); y2=y(Th:T,:);
    beta=PMGe(y,x,1);
    betaa=PMGe(y1,x1,1);
    betab=PMGe(y2,x2,1);
    kappa=1/3;
betajack=beta-kappa*((betaa+betab)/2-beta);
betajackall=betaall-kappa*((betaalla+betaallb)/2-betaall);
tjackall=(betajackall-Q.beta)./sball;
Res.jack13.betahat=betajack;
Res.jack13.var=Q.var; %var(betajackall);
Res.jack13.cv=quantile(abs(tjackall),0.95);

% jackknife corrected using kappahat
kappahat=bias/(bias2-bias);
betajackhat=beta-kappahat*((betaa+betab)/2-beta);
betajackallhat=betaall-kappahat*((betaalla+betaallb)/2-betaall);
Res.jackhat.betahat=betajackhat;
Res.jackhat.var=Q.var; %var(betajackallhat);
tjackhatall=(betajackallhat-Q.beta)./sball;
Res.jackhat.cv=quantile(abs(tjackhatall),0.95);


return