% This script is for batch submission of job_MC_for_cluster.m job to a cluster.
% This job computes MC experiments in 
% "Pooled Bewley Estimator of Long Run Relationships in Dynamic Heterogenous Panels"
% by A. Chudik, M.H. Pesaran and R. Smith, May 2021.
% See ReadMe.txt for additional details
% Settings below will need to be configured for a specific cluster available to you.


%% cluster settings
qn='normal'; % this is queue name (check cluster for available queue names)
nd=16; % number of CPU cores per node   
numw=nd*126; % number of computing cores to be requested
efNumberofWorkers=numw-1; % effective number of Matlab workers = numw-1
c=parcluster('bigtex R2019a'); % cluster name
c.AdditionalProperties.QueueName = qn; 
folder_for_saving_results_on_the_cluster='/home/USERNAME/PMG'; % choose the desired folder where results will be saved    

%% submit job to the specified cluster    

jb=batch(c, 'job_MC_for_cluster', 'Pool', efNumberofWorkers, 'CurrentFolder', folder_for_saving_results_on_the_cluster );

disp('Jobs submission script has finished. Check cluster for details on the submitted job.')
